<?php
namespace App\Controller;

use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;

class Dashboard {

    private $dashboardService;

    public function __construct(\App\Service\Dashboard $dashboardService) 
    {
        $this->dashboardService = $dashboardService;
    }

    public function dashboard(Request $request, Response $response) 
    {
        try {
            $params = $request->getParsedBody();

            $dtInicial = !empty($params['dtInicial']) ? $params['dtInicial'] : null;
            $dtFinal = !empty($params['dtFinal']) ? $params['dtFinal'] : null;

            if (empty($params['dtInicial']) || empty($params['dtFinal'])) {
                throw new \Exception("Data inicial/final não informada.");
            }
            
            $result = $this->dashboardService->dashboard($dtInicial, $dtFinal);

            $response->getBody()->write(json_encode([
                'error' => false,
                'message' => "Dados do Dashboard adquiridos com sucesso.",
                'data' => $result
            ]));

            return $response->withHeader('Content-Type', 'application/json');
        } catch (\Exception $e) {
            $response->getBody()->write(json_encode([
                'error'   => true,
                'message' => $e->getMessage(),
                'data'    => []
            ]));

            return $response->withHeader('Content-Type', 'application/json');
        }
    }
}